package com.pratap.zebrascanner;

import android.content.Intent;

import androidx.annotation.NonNull;
import android.content.Context;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.plugin.common.EventChannel.StreamHandler;
import io.flutter.plugin.common.EventChannel;


import android.app.Activity;

import com.pratap.zebrascanner.activities.SplashScreenActivity;
import com.pratap.zebrascanner.application.Application;

/**
 * ZebrascannerPlugin
 */
public class ZebrascannerPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware,StreamHandler {

    //
    private String channelName = "com.pratap.zebrascanner/zebra";
    private String eventChannelName = "com.pratap.zebrascanner/zebraevents";

    private MethodChannel channel;
    private EventChannel eventChannel;
    private Context context;
    private EventChannel.EventSink sink = null;


    private Activity activity;

    //private Result pendingResult;

    @Override
    public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {

        context = flutterPluginBinding.getApplicationContext();

        channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), channelName);
        channel.setMethodCallHandler(this);


        eventChannel = new EventChannel(flutterPluginBinding.getBinaryMessenger(), eventChannelName);
        eventChannel.setStreamHandler(this);
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
        if (call.method.equals("getPlatformVersion")) {
            result.success("Android " + android.os.Build.VERSION.RELEASE);
        } else if (call.method.equals("barcodeScreen")) {


            Intent zebraIntent= new Intent(activity, SplashScreenActivity.class);
            activity.startActivity(zebraIntent);



        } else {
            result.notImplemented();
        }
    }

    @Override
    public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
        channel.setMethodCallHandler(null);
        eventChannel.setStreamHandler(null);
    }

    @Override
    public void onAttachedToActivity(@NonNull ActivityPluginBinding binding) {
        activity = binding.getActivity();

        //activityPluginBinding.addActivityResultListener(this);
    }

    @Override
    public void onDetachedFromActivityForConfigChanges() {

    }

    @Override
    public void onReattachedToActivityForConfigChanges(@NonNull ActivityPluginBinding binding) {

    }

    @Override
    public void onDetachedFromActivity() {

        activity = null;

    }

    @Override
    public void onListen(Object arguments, EventChannel.EventSink events) {
        android.util.Log.i("OnListen", "adding listener");
        sink = events;
        Application.setEventSink(sink);
    }

    @Override
    public void onCancel(Object arguments) {
        android.util.Log.i("OnCancel", "cancelling listener");
        sink = null;
    }



}
